//---------------------------------------------------------------------------
#ifndef BCGLVPH
#define BCGLVPH
//---------------------------------------------------------------------------
#include <vcl\SysUtils.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Classes.hpp>
#include <vcl\Forms.hpp>
//---------------------------------------------------------------------------
class TOpenGLViewport : public TWinControl
{
private:
        TNotifyEvent			FOnRender;
        HANDLE                  rc;
        HDC                     dc;
        TOpenGLViewport*        shareVP;
        void __fastcall CreateContext();
        void __fastcall DestroyContext();
protected:
        HIDESBASE MESSAGE void __fastcall WMDestroy(TMessage& message);
        HIDESBASE MESSAGE void __fastcall WMEraseBkgnd(TMessage& Message);
        HIDESBASE MESSAGE void __fastcall WMPaint(Messages::TWMPaint& Message);

    BEGIN_MESSAGE_MAP
        MESSAGE_HANDLER(WM_DESTROY, TMessage, WMDestroy)
        MESSAGE_HANDLER(WM_ERASEBKGND, TMessage, WMEraseBkgnd)
        MESSAGE_HANDLER(WM_PAINT, Messages::TWMPaint, WMPaint)
    END_MESSAGE_MAP(TWinControl)

public:
        __fastcall virtual TOpenGLViewport(TComponent* Owner);

        // Share resources with the given OpenGL viewport - this must be called
        // before any painting is done!
        void __fastcall ShareResourcesWith(TOpenGLViewport* vp);

        // Attempts to make the OpenGL context the current one (not needed in OnRender)
        bool __fastcall MakeCurrent() const;

        // Swaps the OpenGL buffers (not needed in OnRender)
        void __fastcall SwapBuffers() const;
__published:
		__property TNotifyEvent OnRender = {read=FOnRender, write=FOnRender};

		// Standard events
		__property Align;
		__property Cursor;
		__property DragCursor;
		__property DragMode;
		__property Enabled;
		__property Font;
		__property ParentFont;
		__property ParentShowHint;
		__property PopupMenu;
		__property ShowHint;
		__property TabStop;
		__property Visible;
		__property OnClick;
		__property OnDblClick;
		__property OnDragDrop;
		__property OnDragOver;
		__property OnEndDrag;
		__property OnEnter;
		__property OnExit;
		__property OnKeyDown;
		__property OnKeyPress;
		__property OnKeyUp;
		__property OnMouseDown;
		__property OnMouseMove;
		__property OnMouseUp;
		__property OnStartDrag;
};
//---------------------------------------------------------------------------
#endif
